/*
 * DataFILEClass.h
 *
 *  Created on: Mar 19, 2010
 *      Author: roger
 */

#ifndef DATAFILECLASS_H_
#define DATAFILECLASS_H_

#include <string>
#include <vector>
#include <iostream>
#include <fstream>

#include "parameters.hpp"
#include <boost/date_time/posix_time/posix_time.hpp>

using namespace std;
// Class for reading & storing data
class DataFILEClass {
public:
        DataFILEClass(string aFile);
        virtual ~DataFILEClass();

protected:
	int nb_c,nb_l;		//Matrix dimensions
        bool end_file;		// to be removed when data read live
	string inputfile;	// data file -> to be removed when data read live
        vector<double*> data;
	int index_counter;
        int *matrixFilter;                      // matrix filter filled by 'getMaxFilter'
        vector<int> timedata;                   // vector of time values


public:
	void readHeader();		//reads the header of the file
	void removeMatrix();	//removes a matrix vector
        void readMatrix(int mat_index);		//reads a matrix from the file
	void readNextMatrix();		//reads the following matrix from file
	double getMat(int i,int j);	//returns data(i,j) of the oldest matrix
	int getNbMat();			// returns the number of matrices currently in memory
	bool checkIndex();		// verifies that the index_counter is still within bounds
        int normalizeData(int s_buf,int index);
        void getMaxFilter(int* s_buf);// fills in a matrix filter to reduce noise
        int getTime();                          // returns oldest data time
};

#endif /* DATAFILECLASS_H_ */
