//( directafferents.cpp


#include "directafferents.hpp"

/**
 *
 *  ratio of the stimulus
 *
 **/
const double localStimulusIntensity = -1300; //-1300.0;//-75.0

//( DirectAfferents

DirectAfferents::DirectAfferents(const int numberOfAfferents,bool spikePreLearning)
{
  createNeurons(numberOfAfferents,
		myLifNeuronModel,
		lifVector,
		false, //noiseflag
		false, // hebb learning
		spikePreLearning,
		false); //spike post


  //createPostsynapticConnections(pyramidalCellsVector, Synapse::AMPAReceptor, false, true);
  //createOneConnections(stimulusNeuronsVector, pyramidalCellsVector, Synapse::AMPAReceptor, stimulusNeuronWeight/1.7);
}


DirectAfferents::~DirectAfferents()
{
    //cout << "~DirectAfferents" <<endl;
}

NeuralNetwork::NeuronsVector & DirectAfferents::getAfferentNeuronsVector()
{
  return lifVector;
}

NeuralNetwork::NeuronsVector & DirectAfferents::getMainNeuronsVector()
{
    return lifVector;
}

void DirectAfferents::setStimulus(vector<double> & inputs)
{
    if (inputs.size()!=lifVector.size())
    {
        cout << "Nombre d'inputs incohérent" << endl;
        cout << inputs.size() << "\t" << lifVector.size() << endl;
    }

    NeuronsVector::const_iterator iterator = lifVector.begin();
    int size=inputs.size();
    for(int i=0; i<size;i++)
    {
        (*iterator)->setStimulus(inputs[i]*localStimulusIntensity);
//        cout << inputs[i] << "\t";
        iterator++;
    }
    //cout <<endl;
}

void DirectAfferents::setStimulus(double input)
{
    for(NeuronsVector::const_iterator ite = lifVector.begin(); ite!=lifVector.end();ite++)
    {
        (*ite)->setStimulus(input*localStimulusIntensity);
    }
}


vector< list<double> > DirectAfferents::getSpikeTimeList()
{
    vector< list<double> > result;

    for(NeuronsVector::const_iterator ite = lifVector.begin(); ite!=lifVector.end();ite++)
    {
        result.push_back(((LifNeuron *)(*ite))->getSpikeTimeList());
    }
    return result;
}


void DirectAfferents::printAllWeights(ofstream & weightsStream)
{
  NeuronsVector::iterator iterator=lifVector.begin();
  //cout << "vector size: " << lifVector.size() << endl;
  for(unsigned int index=0; index<lifVector.size(); index++)
    {
      (*iterator)->printAllWeights(weightsStream);
      weightsStream << endl;
      iterator ++;
    }
}

//) DirectAfferents


//) directafferents.cpp
