#ifndef EDLUT_H
#define EDLUT_H

#include "parameters.hpp"

#include "simulation/Simulation.h"
#include "communication/ArrayInputSpikeDriver.h"
#include "communication/ArrayOutputSpikeDriver.h"
#include "spike/EDLUTFileException.h"
#include "spike/EDLUTException.h"

#include <fstream>
#include <QVector>
#include <vector>
#include <QSemaphore>
#include <QList>
#include "seperateletters.h"
//#include <QString>
//#include <QChar>

#include "sen2matlab.h"

extern QSemaphore *StoreDisplayEDLUTSemaphore;
extern QVector<int> *DisplayEDLUTSpikeData;
extern QVector<int> *DisplayEDLUTTimeData;

//extern Sen2Matlab * MATLAB;

//#define edNET "../CN_NETWORK/NETp8-20.dat"
//#define edWGH "../CN_NETWORK/WGHp8-20.dat"

class EDLUT
{
public:
    EDLUT();
    ~EDLUT();

    int nb_spikes;
    double last_timebb;
    double SimulationTime;
    QVector<double> InputSpikeTimes;
    QVector<long int> InputSpikeCells;
    int lastSIMULtime;

    seperateLetters* Sproc;
    //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    Sen2Matlab * MATLAB;
    //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    ArrayInputSpikeDriver * InputDriver;
    ArrayOutputSpikeDriver * OutputDriver;
    Simulation * Simul;

    ofstream OUTPUTS;
    bool saveData;

    void AddData(vector<int> &data,int &time);
    void addSortedData();                                   // adding data to EDLUT after it has been sorted
    void AddDataForSorting(vector<int> &data,int &time);    // sorts the data for seperating letters
    void runLetterSeperation();
    void RunSimul();
    void START();
    void STOP();
};

#endif // EDLUT_H
