#include "fingerthread.h"

fingerThread::fingerThread(std::string afilename)
{
    filename = afilename;
    try
    {
        DATAchain = new DataClass(filename);
    }
    catch(int e)
    {
//        delete DATAchain;
//        DATAchain=NULL;
        throw e;
    }
    nbMat = 0;
}

fingerThread::~fingerThread()
{
    writingThread_isrunning=false;
    delete DATAchain;
}

void fingerThread::run()
{
    writingThread_isrunning=true;
    double seconds = acq_period-1;                                            // time between two acquisitions (in ms) => #define
    boost::posix_time::ptime endwait = boost::posix_time::ptime(boost::posix_time::microsec_clock::universal_time());   // gets current time
    boost::posix_time::time_duration t_elapsed;                                                                         // a duration used for mesuring time between two acquisitions (approx) in order to optimize process utility

    while(true)
    {
        this->setTerminationEnabled(false);
        t_elapsed = boost::posix_time::ptime(boost::posix_time::microsec_clock::universal_time()) - endwait;            // time since last acquisition
        if (/*doRecord==true &&*/ t_elapsed.total_milliseconds()>= seconds)									// if elapsed time > acquisition time objective
        {
            endwait = endwait + boost::posix_time::milliseconds(seconds);						// updates time of next acquisition
            DATAchain->readMatrix();											// read data from file
        }
        if(DATAchain->getNbMat()>0  && writingSemaphore->tryAcquire(1))                                                 // writing in shared memory (when possible)
        {
            for (int i=0;i<NBL;i++)
            {
                for (int j=0;j<NBC;j++)
                {
                    sharedData[i][j]=DATAchain->getMat(i,j);
                }
            }
            sharedTime = DATAchain->getTime();
            readingSemaphore->release(1);
            DATAchain->removeMatrix();
        }
        this->setTerminationEnabled(true);
//        std::cout<<DATAchain->getNbMat()<< std::endl;
        nbMat = DATAchain->getNbMat();
    }
    writingThread_isrunning=false;
    DATAchain->Close();
}
