#include "parameters.hpp"


using namespace std;



const string s_SerialPort = charParser("SerialPort");                       // name of the serial port
const char* SerialPort = s_SerialPort.c_str();
const int nb_char = intParser("nb_char");                                   // number of 'chars' to be read per packet
const string s_sensibility = charParser("sensibility");                     // sensibility of mecanoreceptors (C = low | D = medium | E = high) /* NOT USED */
const char* sensibility = s_sensibility.c_str();
const int PAD_sleep_state = intParser("PAD_sleep_state");                   // value of PAD during sleeping state
const int NBL = intParser("NBL");                                           // number of lines in finger matrix
const int NBC = intParser("NBC");                                           // number of colomns in finger matrix
const int acq_period = intParser("acq_period");                             // time between two acquisitions in ms (lower bound)

const int matrix_display_period = intParser("matrix_display_period");       // period between two displays of finger matrix (in nb of data aquisitions)
const int spike_display_period = intParser("spike_display_period");         // period between two refresh of spike plot (in nb of data aquisitions)
const int nbSpikePoints = intParser("nbSpikePoints");                       // number of time "points" in spike plot
const int XaxisTimeWindow = intParser("XaxisTimeWindow");                   // length of the xAxis for spike plot (in ms)

const int max_nb_matrix_sent = intParser("max_nb_matrix_sent");             // number of matrixes to be sent (TEMPORARY : as ong as no manual stop option implemented !!!)

const string s_saveSPIKEfile = charParser("saveSPIKEfile");                 // file to save spikes in
const char* saveSPIKEfile = s_saveSPIKEfile.c_str();
const string s_saveMATfile =  charParser("saveMATfile");                    // file to save finger acquisition matrixes in
const char* saveMATfile = s_saveMATfile.c_str();

const float gaussian_radius = intParser("gaussian_radius");                 // gaussian kernel first radius
const float gaussian_radius2 = intParser("gaussian_radius2");               // gaussian kernel second radius
const float synapse_sensibility = intParser("synapse_sensibility");         // multiplier factor of mecanoreceptor data
const float static_threshold = intParser("static_threshold");               // threshold to limit finger noise (in % of sleep state value)
const float dynamic_threshold = intParser("dynamic_threshold");             // threshold to limit finger noise (in % of maximum currently mesured value)

const int useFILE = intParser("useFILE");                                   // 1 if read from file || 0 read from serial port
const string s_FILEpath = charParser("FILEpath");                           // path of the file were data will be read
const char* FILEpath = s_FILEpath.c_str();
const int useFILEfilter = intParser("useFILEfilter");                       // 1 use filter on data read from file || 0 ignore filter when reading from data file
const int  useSPIKEdisplay = intParser("useSPIKEdisplay");                  // 1 displays spikes in 'real time' || 0 does not display spikes in real time

const int readSpeed = intParser("readSpeed");                               // 1 reads speed from mat file || 0 no speed in mat file

const string s_saveUnMATfile = charParser("saveUnMATfile");                 // file to save unfiltered finger acquisition matrixes in
const char* saveUnMATfile = s_saveUnMATfile.c_str();
const string s_saveCNfile = charParser("saveCNfile");                       // file to save cuneate nucleus spikes in
const char* saveCNfile = s_saveCNfile.c_str();

//const string s_CN_WGH = charParser("CN_WGH");                               // file containing EDLUT CN weights
//const char* CN_WGH = s_CN_WGH.c_str();
//const string s_CN_NET = charParser("CN_NET");                               // file containing EDLUT CN network description
//const char* CN_NET = s_CN_NET.c_str();
const char * CN_WGH = "CN_WGH";                                       // config file reference to file containing EDLUT CN weights
const char * CN_NET = "CN_NET";                                       // config file reference to file containing EDLUT CN network description
const int EDLUTtimeDelay = intParser("EDLUTtimeDelay");                        // delay of upward communication of sensoritmotor information (implimented at EDLUT level) in ms

const int saveCNspikes = intParser("saveCNspikes");                         // 1 save cuneate nucleus spikes in file || 0 do not save cuneate nucleus spikes in file
const int saveLIFspikes = intParser("saveLIFspikes");                       // 1 save mechanoreceptor spikes in file || 0 do not save mechanoreceptor spikes in file
const int saveFILTEREDmat = intParser("saveFILTEREDmat");                   // 1 save filtered matrices in file || 0 do not save filtered matrices in file
const int saveRAWmat = intParser("saveRAWmat");                             // 1 save raw matrices in file || 0 do not save raw matrices in file

const int useCN = intParser("useCN");                                       // 1 use EDLUT cuneate nucleus model || 0 do not use cuneate nucleus

const string s_MatlabAddress = charParser("MatlabAddress");                       // LAN address of matlab classification process (for UDP connection)
const char* MatlabAddress = s_MatlabAddress.c_str();
const string s_ThisAddressM = charParser("ThisAddressM");                           // LAN adresse of the computer running SpikeBuilder
const char* ThisAddressM = s_ThisAddressM.c_str();
const string s_SendPort = charParser("SendPort");                                 // Port used to send data to matlab classification process
const char* SendPort = s_SendPort.c_str();
const string s_RecPort = charParser("RecPort");                                   // Port for receiving results of classification from Matlab
const char* RecPort = s_RecPort.c_str();

const string s_robotAddress = charParser("robotAddress");                   // LAN address of the robot controller
const char * robotAddress = s_robotAddress.c_str();
const string s_SendRobotPort = charParser("SendRobotPort");                 // Port used to send orders to robot
const char * SendRobotPort = s_SendRobotPort.c_str();
const string s_RecRobotPort = charParser("RecRobotPort");                   // Port used for receiving info from robot
const char * RecRobotPort = s_RecRobotPort.c_str();
const string s_ThisAddressR = charParser("ThisAddressR");			// LAN address of the computer running SpikeBuilder (viewed by Robot)
const char * ThisAddressR = s_ThisAddressR.c_str();

const string s_SimulatorAddress = charParser("SimulatorAddress");
const char * SimulatorAddress = s_SimulatorAddress.c_str();                   // LAN address of the finger Simulator process
const string s_ThisAddressS = charParser("ThisAddressS");
const char * ThisAddressS = s_ThisAddressS.c_str();			// LAN address of the computer running SpikeBuilder (viewed by Simulator)
const string s_SendFingerSIMPort = charParser("SendFingerSIMPort");
const char * SendFingerSIMPort = s_SendFingerSIMPort.c_str();                  // Port used to send orders to Simulator
const string s_RecFingerSIMPort = charParser("RecFingerSIMPort");
const char * RecFingerSIMPort = s_RecFingerSIMPort.c_str();                   // Port used for receiving finger sensor data from Simulator

const int seperation_Threshold = intParser("seperation_Threshold");         // threshold for detecting a new letter on the sensors

//const int CNsize = intParser("CNsize");                                     // size of the CN network (ie number of output neurons)

const string s_BrailleFile = charParser("BrailleFile");                         // file containing Braille Line to be read
const char * BrailleFile = s_BrailleFile.c_str();

const int robotSPEED = intParser("robotSPEED");                             // Mvt Speed of robot

const string s_CerebellumAddress = charParser("CerebellumAddress");
const char * CerebellumAddress = s_CerebellumAddress.c_str();                  // LAN address of computer running Cerebellum
const string s_SendCerebellumPort = charParser("SendCerebellumPort");
const char * SendCerebellumPort = s_SendCerebellumPort.c_str();                 // Port used to send information to cerebellum
const int CerebellumCommDelay = intParser("CerebellumCommDelay");			// Delay in communication between Joker and Cerebellum via SpikeBuilder (in ms)

const int fingerWidth = intParser("fingerWidth");                           // width of the finger (in 10^-2mm)
const int fingerHeight = intParser("fingerHeight");                         // height of the sensitive part of the finger (in 10^-2mm)
const int fingerSprecision = intParser("fingerSprecision");            // precision of finger - in mm
const int letterWidth = intParser("letterWidth");				// width of a Braille Letter (ine 10^-2mm)
const int letterHeight = intParser("letterHeight");				// height of a Braille Letter (ine 10^-2mm)

const string s_saveClassResults = charParser("saveClassResults");
const char * saveClassResults = s_saveClassResults.c_str();                                                 // file to save classification results

float intParser(const char* achar)
{
    ifstream confFILE ( configfile );
    stringstream tmp_stream;
    string tmp_string;
    bool discard = false;

    if ( confFILE.is_open() )
    {
        string line;
        while ( getline ( confFILE, line ) )
        {
            discard = false;
            tmp_string.clear();
            string::size_type i = line.find_first_not_of ( " \t\n\v" );
            if ( i != string::npos  && line[0]!='#')
            {
                tmp_stream.str(line);
                while (tmp_stream >> tmp_string && !discard)
                {
                    if (tmp_string[0]!='#' && tmp_string.compare(achar)==0)
                    {
                        float result;
                        tmp_stream >> result;
                        confFILE.close();
                        return result;
                    }
                    else
                    {
                        discard = true;
                    }
                }
            }
        }
    }
    confFILE.close();
    return intMissingPARAM(achar);
}

string charParser(const char* achar)
{
    ifstream confFILE ( configfile );
    stringstream tmp_stream;
    string tmp_string;
    bool discard = false;

    if ( confFILE.is_open() )
    {
        string line;
        while ( getline ( confFILE, line ) )
        {
            discard = false;
            tmp_string.clear();
            string::size_type i = line.find_first_not_of ( " \t\n" /*" \t\n\v"*/ );
            if ( i != string::npos && line[0]!='#')
            {
                tmp_stream.str(line);
                while (tmp_stream >> tmp_string && !discard)
                {
                    if (tmp_string[0]!='#' && tmp_string.compare(achar)==0)
                    {
                        string result;
                        tmp_stream >> result;
                        if (strcmp(achar,"gnuplot_script")==0)
                        {
                            string tt = "gnuplot -persist ";
                            result = tt + result;

                        }
                        confFILE.close();
                        return result;
                    }
                    else
                    {
                        discard = true;
                    }
                }
            }
        }
    }
    confFILE.close();
    return charMissingPARAM(achar);
}

float intMissingPARAM(const char* achar)
{
    cout << "Parameter not found in file (using default value) : " << achar << endl;
    if (strcmp(achar,"nb_char")==0)
        return 49;
    if (strcmp(achar,"PAD_sleep_state")==0)
        return 200;
    if (strcmp(achar,"NBL")==0)
        return 4;
    if (strcmp(achar,"NBC")==0)
        return 6;
    if (strcmp(achar,"acq_period")==0)
        return 45;
    if (strcmp(achar,"matrix_display_period")==0)
        return 5;
    if (strcmp(achar,"spike_display_period")==0)
        return 30;
    if (strcmp(achar,"nbSpikePoints")==0)
        return 50;
    if (strcmp(achar,"max_nb_matrix_sent")==0)
        return 3000;
    if (strcmp(achar,"gaussian_radius")==0)
        return 0.044;
    if (strcmp(achar,"gaussian_radius2")==0)
        return 0;
    if (strcmp(achar,"synapse_sensibility")==0)
        return 0.1;
    if (strcmp(achar,"XaxisTimeWindow")==0)
        return 2000;
    if (strcmp(achar,"static_threshold")==0)
        return 10;
    if (strcmp(achar,"dynamic_threshold")==0)
        return 70;
    if (strcmp(achar,"useFILE")==0)
        return 0;
    if (strcmp(achar,"useFILEfilter")==0)
        return 1;
    if (strcmp(achar,"useSPIKEdisplay")==0)
        return 1;
    if (strcmp(achar,"readSpeed")==0)
        return 0;
    if (strcmp(achar,"saveCNspikes")==0)
        return 1;
    if (strcmp(achar,"saveLIFspikes")==0)
        return 1;
    if (strcmp(achar,"saveFILTEREDmat")==0)
        return 1;
    if (strcmp(achar,"saveRAWmat")==0)
        return 1;
    if (strcmp(achar,"useCN")==0)
        return 1;
    if(strcmp(achar,"CNsize")==0)
        return 100;
    if(strcmp(achar,"seperation_Threshold")==0)
        return 1;
    return 0;
}

string charMissingPARAM(const char* achar)
{
    cout << "Parameter not found in file (using default value) : " << achar << endl;
    if (strcmp(achar,"SerialPort")==0)
        return "/dev/ttyUSB0";
    if (strcmp(achar,"sensibility")==0)
        return "D";
    if (strcmp(achar,"saveSPIKEfile")==0)
        return "../LIF_spikes.dat";
    if (strcmp(achar,"saveMATfile")==0)
        return "../filtered_mat.dat";
    if (strcmp(achar,"FILEpath")==0)
        return "../mat_examples.dat";
    if (strcmp(achar,"saveUnMATfile")==0)
        return "../unfiltered_mat.dat";
    if (strcmp(achar,"saveCNfile")==0)
        return "../CN_spikes.dat";
    if (strcmp(achar,"CN_WGH")==0)
        return "./WGH.dat";
    if (strcmp(achar,"CN_NET")==0)
        return "./NET.dat";
    if (strcmp(achar,"MatlabAddress")==0)
        return "192.168.1.6";
    if (strcmp(achar,"ThisAddress")==0)
        return "192.168.1.12";
    if (strcmp(achar,"SendPort")==0)
        return "25251";
    if (strcmp(achar,"RecPort")==0)
        return "25252";
    if (strcmp(achar,"RecRobotPort")==0)
        return "64550";
    if (strcmp(achar,"SendRobotPort")==0)
        return "64500";
    if (strcmp(achar,"robotAddress")==0)
        return "10.17.246.210";
    return 0;
}
