#include "processthread.h"

ProcessThread::ProcessThread()
{
//    eSim = new EDLUT();
    eSim->START();
    fingerMat = new double*[NBL];
    for(int i=0;i<NBL;i++)
    {
        fingerMat[i]=new double[NBC];
        for(int j=0;j<NBC;j++)
        {
            fingerMat[i][j] = 0;
        }
    }
    if(saveFILTEREDmat)
    {
        savefile.open(saveMATfile);
    }
}

ProcessThread::~ProcessThread()
{
    for(int i=0;i<NBL;i++)
    {
        delete[] (fingerMat[i]);
    }
        delete[] fingerMat;

    readingThread_isrunning = false;
    eSim->STOP();
//    delete eSim;
//    eSim = NULL;
    if(savefile.is_open())
        savefile.close();
}

void ProcessThread::run()
{
    readingThread_isrunning = true;
    initFileTime();

    int data_counter=0;                   // counter for nb of data packets received
    std::string tempstr = saveSPIKEfile;
    DataPlayfield * DataOps = new DataPlayfield(NBL,NBC,tempstr);             // class for running model

    while(!writingThread_isrunning)
    {
        usleep(1000);
    }

    while(writingThread_isrunning)
    {
        this->setTerminationEnabled(false);
        if(readingSemaphore->tryAcquire(1))
        {
            for(int i=0;i<NBL;i++)
            {
                for(int j=0;j<NBC;j++)
                {
                    fingerMat[i][j] = (int)sharedData[i][j];
                }
            }
            TimeSaveStruct->saveTime(sharedTime);
            saveData(sharedTime);
            eSim->Sproc->updateTime(sharedTime);
            data_counter++;
            writingSemaphore->release(1);

            if (data_counter==1)
                DataOps->firstRun(fingerMat);
            else
                DataOps->play(fingerMat);
        }
        emit OperationCompleteFeedback();       // put it in the if block ?
        this->setTerminationEnabled(true);
    }

    delete DataOps;
    readingThread_isrunning = false;
}

void ProcessThread::saveData(int stime)
{
    bool tOK = false;
    saveDataOKSemaphore->acquire(1);
    tOK = saveDataOK;
    saveDataOKSemaphore->release(1);
    if(tOK && saveFILTEREDmat)
    {
        for(int i=0;i<NBL;i++)
        {
            for(int j=0;j<NBC;j++)
            {
                savefile << fingerMat[i][j];
                savefile << "   ";
            }
        }
        savefile << stime << endl;;
        savefile.flush();
    }
}

void ProcessThread::initFileTime()
{
    if(saveFILTEREDmat)
    {
        boost::posix_time::ptime startTIME = boost::posix_time::ptime(boost::posix_time::microsec_clock::universal_time());   // gets start time of program
        savefile << startTIME << "\n";
    }
}
