#include "receivefrobot.h"

QSemaphore* sharedRSPSemaphore = new QSemaphore(1);
rspType* sharedRSP = new rspType;

bool send2RobotOK = false;
QSemaphore * send2RobotOKSemaphore = new QSemaphore(1);

receiveFrobot::receiveFrobot()
{
    TrialCounter = 0;
}

int receiveFrobot::listen2socket()
{
    try
    {
        string senderAddress = robotAddress;
        string myAddress = ThisAddressR;
        unsigned short recPort = Socket::resolveService(RecRobotPort,"udp");

        UDPSocket rec_sock;
        rec_sock.setLocalAddressAndPort(myAddress, recPort);
        int recvMsgSize = rec_sock.recvFrom(&RSP, sizeof(RSP), senderAddress, recPort);
    }
    catch (SocketException &e)
    {
        cout << e.what() << endl;
        return 1;
    }

    //    sharedRSPSemaphore->acquire(1);     // maybe replace acquire by tryAcquire + wait time
    //    sharedRSP = &RSP;
    //    sharedRSPSemaphore->release(1);

    return 0;

}

void receiveFrobot::run()
{
    double lastFlag = 0;
    double lastTime = -1;
    bool tOK = false;
    while(1)
    {
        send2RobotOKSemaphore->acquire(1);
        tOK = send2RobotOK;
        send2RobotOKSemaphore->release(1);
        if(tOK)
        {
            listen2socket();
//            printf("time received : %f || last time : %f\n",RSP.timestamp,lastTime);
            if(RSP.timestamp>lastTime)
            {
                lastTime = RSP.timestamp;
                sharedRSPSemaphore->acquire(1);     // maybe replace acquire by SIGNAL+SLOT
                sharedRSP = &RSP;
                sharedRSPSemaphore->release(1);

//                printf("RobotStatus : %f\n",RSP.Rstatus);
                if(RSP.Rstatus == 0 && (lastFlag == -3 || lastFlag == -2 || lastFlag == -1))
                {
                    TrialCounter ++;
                    emit updateRobotFlag(3);
                    printf("Trial Number: %d\n",TrialCounter);
                    emit nextLine();
                }
                else if((RSP.Rstatus == -2))
                {
                    //new initialisation
                    emit updateRobotFlag(-1); // or 2 depending on implementation of initPos
                    emit PauseRec(false);
                }
                else if(RSP.Rstatus==3)
                {
//                    emit posSIG(RSP.xpos);
                    emit PauseRec(true);

                }
                else if(RSP.Rstatus==-1)
                {
                    emit updateRobotFlag(3);
                }
                else if(RSP.Rstatus==-3)
                {
                    emit updateRobotFlag(-3);
                }
                lastFlag = RSP.Rstatus;
            }
            RSP.clean();
        }
        else
        {
            usleep(100000);
        }
    }
}
