#include "sen2matlab.h"



Sen2Matlab::Sen2Matlab()
{
    timestamp = 0;
}

void Sen2Matlab::reset()
{
    data.clean();
}

int Sen2Matlab::Send()
{
    string servAddress = MatlabAddress;
    unsigned short echoServPort = Socket::resolveService(SendPort,"udp");
    timestamp ++;
    data.timeStamp = timestamp;
    try
    {
        UDPSocket sock;
        printf("SENDING 2 Matlab : timestamp %f || vx %f\n",data.timeStamp,data.vx);
        sock.sendTo(&data, sizeof(data), servAddress, echoServPort);
    }
    catch (SocketException &e)
    {
        cerr << e.what() << endl;
        return 1;
    }
//    cout << "Command sent.\n";

    reset();

    return 0;

}

void Sen2Matlab::computeSpikeCounts(int nb,long int * OutputSpikeCells)
{
    for(int i=0;i<nb;i++)
    {
        data.counts[OutputSpikeCells[i]-24]++;
    }
    sharedRSPSemaphore->acquire(1);
    printf("sharedRSP->xspeed: %d\n",sharedRSP->xspeed);
    data.vx = sharedRSP->xspeed;
//    data.statusFlag = sharedRSP->Rstatus;
    sharedRSPSemaphore->release(1);
}
