#ifndef SEN2MATLAB_H
#define SEN2MATLAB_H

#include <iostream>
#include "PracticalSocket.h"
#include "parameters.hpp"
#include "receivefrobot.h"

//#define Matlabaddress "192.168.178.25"
//#define Matlabport "25251"

#define CNsize 100


struct sendInfo
{
    sendInfo()
    {
        clean();
    };
    void clean()
    {
        for ( int j=0; j<(int)CNsize; ++j ) counts[j] = 0;
        timeStamp = 0;
        vx = 0;
        vy = 0;
        vz = 0;
        posx = 0;
        posy = 0;
        posz = 0;
    }
    double timeStamp;
    double vx;                   // last known speed of the robot
    double vy;
    double vz;
    double posx;
    double posy;
    double posz;
    double counts[(int)CNsize];
};

class Sen2Matlab
{
public:
    Sen2Matlab();
    void computeSpikeCounts(int nb,long int * OutputSpikeCells);
    int Send();
    void reset();

    sendInfo data;
    double timestamp;

};

#endif // SEN2MATLAB_H
