#include "seperateletters.h"

seperateLetters::seperateLetters()
{
    timeWindow = 80;
    Sp = seperation_Threshold;//0.8;
    lastTime = 0;
    currentTime = 0;
    nFireR.resize(24);
    oFireR.resize(24);
    recFLAG.resize(4);
    detFLAG.resize(4);

    diffTime = 48;
    saveData = false;

    detFLAG.last() = 1;
    printf("recFLAG : %d | %d | %d | %d\n",recFLAG[0],recFLAG[1],recFLAG[2],recFLAG[3]);

    //////////////////////////////////
//    savefile.open("../filtered_spikes.dat");

    lastActiveLines = NULL;
    letterYpos = -1;
    IncYSpeed = 0.005;
    Vy = 0;
    letter_index = -1;
    ActivityHist.resize(4);
}

seperateLetters::~seperateLetters()
{
//    savefile.flush();
//    savefile.close();
}

void seperateLetters::computeFiringRate()
{
    if(!FspikeTimes.isEmpty())
    {
        // reinitialising firing rate vector
        for(int i=0;i<nFireR.size();i++)
        {
            oFireR[i] = nFireR[i];
            nFireR[i] = 0;
        }

        //        printf("SIZE_IN: %d\n",spikeTimes.size());

        double pastTime = currentTime - timeWindow;                // definition of lower bound of time window
        //        printf("PASTTIME: %f\n",pastTime);
        QList<double>::iterator timeIt = FspikeTimes.begin();
        QList<int>::iterator spikeIt = FspikeNeurons.begin();

        // deleting outdated spikes (outside window)
        //        printf("*timeIt: %f  ||  pastTime: %f\n",*timeIt,pastTime);
        while(!FspikeTimes.isEmpty() && *timeIt<pastTime)
        {
            FspikeTimes.erase(timeIt);
            FspikeNeurons.erase(spikeIt);
            timeIt++;
            spikeIt++;
        }

        //        printf("SIZE_0UT: %d\n",spikeTimes.size());

        for(spikeIt = FspikeNeurons.begin();spikeIt!=FspikeNeurons.end();++spikeIt)
        {
            nFireR[*spikeIt]++;
        }
    }

}

void seperateLetters::addnewSpikes(std::vector<int> & data,int& time)
{
    for(int i=0;i<data[0];i++)
    {
        //        printf("intTIME: %d || doubleTIME: %f\n",time,(double)time);
        spikeTimesIN.push_back((double)time);
        spikeNeuronsIN.push_back(data[i+1]);
        FspikeTimes.push_back((double)time);
        FspikeNeurons.push_back(data[i+1]);
    }
}

void seperateLetters::updateTime(int & time)
{
    currentTime = (double)time;
}

void seperateLetters::tryDetect()
{
    for(int i=0;i<recFLAG.size();i++)
    {
        if(recFLAG[i]==0 && detFLAG[i]==1 && checkSlope(i)>0)
        {
            recFLAG[i]=1;
            if(i==3)
            {
                letter_index++;
                printf("New Letter: %d\n",letter_index);
            }
            if(i>0)
            {
                detFLAG[i-1]=1;
            }
            //            printf("time: %d  -  recFLAG : %d | %d | %d | %d\n",(int)currentTime,recFLAG[0],recFLAG[1],recFLAG[2],recFLAG[3]);
        }
    }
    //    printf("recFLAG : %d | %d | %d | %d\n",recFLAG[0],recFLAG[1],recFLAG[2],recFLAG[3]);

}

int seperateLetters::checkSlope(int column)
{
    int a = column * 6;
    int b = (column+1) * 6;

    int tmp = 0;
    int i = a;

    while(i<b && tmp==0)
    {
        if(nFireR[i]!=0)
        {
            tmp = (int)((nFireR[i] - oFireR[i])>Sp*oFireR[i]) + tmp;
            //            printf("checkSLOPE: %d\n",(int)((nFireR[i] - oFireR[i])>Sp*oFireR[i]));
            //            printf("nFire: %f - oFire %f\n",nFireR[i],oFireR[i]);
            if(tmp == 0)        // ie. if there is a sensor which is active but not increasing
            {
                return 0;
            }
        }
        i++;
    }

    return tmp;

}


void seperateLetters::mainfunc()
{
    computeFiringRate();

    tryDetect();

    addnewSpikesOUT();

    Vy = takeSideMvtDecision();
}

void seperateLetters::addnewSpikesOUT()
{
    if(!spikeTimesIN.isEmpty())
    {
        //         printf("lastTime: %f || spikeTimes FIRST: %f -- LAST: %f\n",lastTime,spikeTimesIN.first(),spikeTimesIN.last());
        QList<double>::iterator timeIt = spikeTimesIN.end();
        QList<int>::iterator cellIt = spikeNeuronsIN.end();
        cellIt--;
        timeIt--;
        while(timeIt!=spikeTimesIN.begin() && *timeIt>lastTime)
        {
            if(recFLAG.at(*cellIt/6)==1)
            {
                spikeNeuronsOUT.push_front(*cellIt);
                spikeTimesOUT.push_front(*timeIt);
                //                printf("spikeTimeOUT : %f\n",*timeIt);
//                if(saveData)
//                {
//                    savefile << *timeIt << "\t" << *cellIt << endl;
//                    savefile.flush();
//                }
            }
            cellIt--;
            timeIt--;
        }
        lastTime = spikeTimesIN.last();
        spikeTimesIN.clear();
        spikeNeuronsIN.clear();
    }
}

void seperateLetters::classification()
{
    recFLAG.clear();
    detFLAG.clear();
    recFLAG.resize(4);
    detFLAG.resize(4);

    FspikeTimes.clear();             //to be removed when we understand why it doesn't work without it
    FspikeNeurons.clear();
    spikeTimesOUT.clear();
    spikeNeuronsOUT.clear();

    int index = findLetterPos();

    if(index<3)
    {
        for(int i=index+1;i<4;i++)
        {
            recFLAG[i] = 1;
            detFLAG[i] = 1;
        }
    }
    detFLAG[index] = 1;
    printf("time: %d  -  DETECTION MADE !!!!!!!!!!!!!\n",(int)currentTime);
    printf("recFLAG : %d | %d | %d | %d\n",recFLAG[0],recFLAG[1],recFLAG[2],recFLAG[3]);

}

void seperateLetters::reinit()
{
    FspikeTimes.clear();
    FspikeNeurons.clear();
    spikeTimesOUT.clear();
    spikeNeuronsOUT.clear();
    spikeTimesIN.clear();
    spikeNeuronsIN.clear();

    nFireR.clear();
    oFireR.clear();
    recFLAG.clear();
    detFLAG.clear();

    nFireR.resize(24);
    oFireR.resize(24);
    recFLAG.resize(4);
    detFLAG.resize(4);

    detFLAG.last() = 1;
    lastTime = 0;
    currentTime = 0;
    printf("time: %d  -  recFLAG : %d | %d | %d | %d\n",(int)currentTime,recFLAG[0],recFLAG[1],recFLAG[2],recFLAG[3]);

    /////////////////////////////////////////
//    savefile.close();
//    savefile.open("../filtered_spikes.dat");
}


int seperateLetters::findLetterPos()
{
    //    // detect columns with activity (firing rate > 0)
    //    QVector<int> active;
    //    active.resize(4);
    //    int tmp = 0;
    //    for(int i=0;i<4;i++)
    //    {
    //        for(int j=0;j<6;j++)
    //        {
    //            tmp = (int)(nFireR[i*6+j]>0)+tmp;
    //        }
    //        active[i]=(int)(tmp>0);
    //        tmp = 0;
    //    }
    //
    //    // detect if there is two consecutive columns with activity
    //    for(int i=0;i<3;i++)
    //    {
    //        if(active[i]==1 && active[i+1]==1)
    //        {
    //            return (i+1);
    //        }
    //    }
    //
    //    // if not two consecutive letters then active column to the right deactivated
    //    for(int i=0;i<4;i++)
    //    {
    //        if(active[i]==1)
    //        {
    //            return i;
    //        }
    //    }

    // else deactivate all
    return 3;

}


int * seperateLetters::detectActiveLines()
{
    int *active = new int[6];
    for(int l =0;l<6;l++)
    {
        active[l] = 0;
        for(int c=0;c<4;c++)
        {
            if(nFireR[l+c*6] > 0)
            {
                active[l] = 1;
                break;
            }
        }
    }

    return active;
}

double seperateLetters::takeSideMvtDecision()
{
    //    printf("YPos:%d\n",letterYpos);
    if(lastActiveLines==NULL)
    {
        lastActiveLines = detectActiveLines();
        return 0;
    }
    else
    {
        int * ActiveLines = detectActiveLines();
        //count nblines + find first indexes
        int idx = -1;
        int cnt = 0;
        int lastidx = -1;
        int lastcnt = 0;
        for(int i=0;i<6;i++)
        {
            //            printf("%d ",ActiveLines[i]);
            if(ActiveLines[i]>0)
            {
                cnt = cnt++;
                if(idx == -1)
                {
                    idx = i;
                }
            }
            if(lastActiveLines[i]>0)
            {
                lastcnt = lastcnt++;
                if(lastidx == -1)
                {
                    lastidx = i;
                }
            }
        }
        //        printf("\n");
        if(letterYpos == -1  && cnt!=0)
        {
            letterYpos = idx;//12 - idx*4;            
        }
        if(cnt == 0 /*|| lastcnt == 0*/)
        {
            lastActiveLines = ActiveLines;
            //            letterYpos = -1;
            return 0;
        }
        else if(letterYpos != -1)
        {
            if(idx>letterYpos)
                return IncYSpeed;
            else if(idx<letterYpos)
                return -IncYSpeed;
            if(cnt>3 || (cnt>lastcnt && lastcnt>0))
                return IncYSpeed;
        }
        return 0;
    }
}

int seperateLetters::PositionQuality()              // 0 no problem detected | 1 noisy position | 2 wrong position
{
    if(letterYpos != -1)
    {
        int * ActiveLines = detectActiveLines();
        //count nblines + find first indexes
        int idx = -1;
        int cnt = 0;
        for(int i=0;i<6;i++)
        {
            //            printf("%d ",ActiveLines[i]);
            if(ActiveLines[i]>0)
            {
                cnt = cnt++;
                if(idx == -1)
                {
                    idx = i;
                }
            }
        }
        if(idx>letterYpos)
        {
            printf("Position Error Detected\n");
            return 2;
        }
        else if(idx<letterYpos  && cnt<=3)
        {
            printf("Position Error Detected\n");
            return 2;
        }
        else if(cnt>3)
        {
            printf("Noisy Position Detected\n");
            return 1;
        }
    }
    return 0;
}

void seperateLetters::setInitPos()
{
    int idx = -1;
    int * ActiveLines = detectActiveLines();
    for(int i=0;i<6;i++)
    {
        //            printf("%d ",ActiveLines[i]);
        if(ActiveLines[i]>0)
        {
            if(idx == -1)
            {
                idx = i;
            }
        }
    }
    letterYpos = idx;
    printf("Letter ref Position set to:%d\n",(12-4*idx));
}

bool seperateLetters::detectEndLetter()
{
    int * ActiveLines = detectActiveLines();
    int cnt = 0;
    int i = 0;
    while(i<6)
    {
        cnt = cnt + ActiveLines[i];
        i++;
    }

    ActivityHist.pop_front();
    if(cnt > 0)
    {
        ActivityHist.push_back(1);
    }
    else
    {
        ActivityHist.push_back(0);
    }


    if(ActivityHist[0] == 1 && ActivityHist[1]==1 && ActivityHist[2]==0 && ActivityHist[3]==0)
    {
        end_of_letter = 1;
        printf("End of Letter detected\n");
    }
}

void seperateLetters::reinitENDofLetter()
{
    end_of_letter = 0;
}
