#ifndef SEPERATELETTERS_H
#define SEPERATELETTERS_H

#include <QList>
#include <QVector>
#include <vector>
//#include "globalVar.h"
#include <stdio.h>
#include "parameters.hpp"


#include <iostream>
#include <string.h>
#include <fstream>
using namespace std;

class seperateLetters
{
public:
    seperateLetters();
    ~seperateLetters();
    void computeFiringRate();                                         // erases old unecessary spikes from memory & calculates firing rates
    void addnewSpikes(std::vector<int> & data,int& time);             // adds new spikes to memory
    void updateTime(int & time);                                      // updates currentTime to value indicated in "time"
//    void sendData2EDLUT();                                          // transfers pertinent data to EDLUT
    void tryDetect();                                                 // try detection of new letters on sensor columns
    int checkSlope(int column);                                       // checks if increase in stimulis is enough to consider new letter for a column
    void mainfunc();                                                  // main function to call, does everything on its own
    void addnewSpikesOUT();                                           // adds new spikes to output vector (to be sent to EDLUT)
    void classification();                                            // deactivates all the sensors when a classification has been made
    void reinit();                                                    // reinitializes the class
    int findLetterPos();                                              // determines the position on the sensors of the letter that was just classified
    int * detectActiveLines();                                         // detects the position of the stimuli through the active lines
    double takeSideMvtDecision();
    void setInitPos();                                                  // saves the initial position of the letter
    int PositionQuality();                                             // evaluates the quality of the position for modulating the decision process
    bool detectEndLetter();                                             // detects the end of a letter

    int timeWindow;                     // time window over which firing rates are calculated (in ms)
    double Sp;                          // coefficient for slope detection (todo: function with speed)
    QList<int> FspikeNeurons;           // queue of spiking LIF neuron indexes for firing rate
    QList<double> FspikeTimes;          // queue of LIF neurons spike times for firing rate
    QList<int> spikeNeuronsIN;          // queue of spiking LIF neuron indexes for CN IN
    QList<double> spikeTimesIN;         // queue of LIF neurons spike times for CN IN
    QVector<double> nFireR;             // vector of newer firing rates (one per LIF neuron)
    QVector<double> oFireR;             // vector of older firing rates (one per LIF neuron)
    double currentTime;                 // current time value (in ms)
    QList<int> spikeNeuronsOUT;         // queue of spiking LIF neuron indexes to be sent to CN
    QList<double> spikeTimesOUT;        // queue of LIF neurons spike times to be sent to CN
    QVector<int> recFLAG;               // flags (one per column) for recording data
    QVector<int> detFLAG;               // flags (one per column) for detecting activation of new sensor column (ie new letter)
    double lastTime;                    // saves last spike time last iteration
    double diffTime;                    // time increment between two function calls
    ofstream savefile;                  // save file for OUT spikes
    int * lastActiveLines;
    int letterYpos;                     // position of letter on Y axis (convention TONY)
    double IncYSpeed;                   // basic speed for moving on Y axis
    double Vy;                          // speed along Y axis
    int letter_index;
    QVector<int> ActivityHist;
    int end_of_letter;               // index of the letter last finished

    void reinitENDofLetter();

    bool saveData;                                                      // boolean describing action of saving files (of filtered spikes)

};

#endif // SEPERATELETTERS_H
