//( temporalskindata.hpp

#ifndef TEMPORALSKINDATA_HPP
#define TEMPORALSKINDATA_HPP


#include <string>
#include <iostream>
#include <fstream>
#include <vector>
#include <stdlib.h>
#include <time.h>

using namespace std;


//( TemporalSkinData

/**
 * class containing the data
 *
 * @author Xavier
 * modified JP
**/
class TemporalSkinData
{
        public:

    TemporalSkinData(int s1,int s2,int nMatrix);
    TemporalSkinData(int s1,int s2);

    ~TemporalSkinData();

    vector<vector<vector<double> > > & getDataVector() {return data;};
    int getNbOfMatrix() {return nbOfMatrix;};
    int getSize1() {return size1;};
    int getSize2() {return size2;};

    TemporalSkinData * getInterpolatedData(int nbOfIntermediateMatricesBetweenTwo);

    void addMatrix(double **dataTab);

    void print();
    void print(const string outputfile);
    void printOutSum(const string outputfile);
    void printOutMax(const string outputfile);

    void normalize();

    void multiply(double factor);
    void addMultiplyingNoise(double noiseFactor);

    vector<double> applyFullKernel(vector<vector<double> > kernel);
    double applyFullKernel(vector<vector<double> > kernel,int matrixIndex);


        private:

    vector<vector<vector<double> > > data;

    int nbOfMatrix;
    int size1;
    int size2;
};

//) TemporalSkinData

#endif

//) temporalskindata.hpp
