//( testafferents.cpp



#include "testafferents.hpp"



//( TestAfferents


TestAfferents::TestAfferents(const string & datafile,
                             const unsigned int nbOfAfferents,
                             const double simulationTime) :
        SimulationTest(simulationTime),
        directAfferents(nbOfAfferents, false)/*,
        outputFile(datafile.c_str())*/
{
    if(saveLIFspikes)
    {
        outputFile.open(datafile.c_str());
    }
    timeIncrement = 0;
//    preciseTime2 = boost::posix_time::ptime(boost::posix_time::microsec_clock::universal_time());
    acq_period = simulationTime;
}

TestAfferents::~TestAfferents()
{
    if(outputFile.is_open())
    {
        outputFile.close();
    }
}


void TestAfferents::setTemporalDataList(vector<vector<double> > * tempDataList)
{
    temporalDataList=tempDataList;
}

void TestAfferents::computeOneStep()
{
    directAfferents.nextStep();
}


void TestAfferents::setConditions()
{
    unsigned int time=(int)(getCurrentTime()/timeStep);

    if (time<(*temporalDataList).size())
    {
        directAfferents.setStimulus((*temporalDataList)[time]);
    }
    else
    {
        directAfferents.setStimulus(0.0);
    }
}


void TestAfferents::printData()
{
//    boost::posix_time::time_duration ttime;
//    ttime = (preciseTime2-preciseTime);
//    directAfferents.printRaster(outputFile,(int)(ttime.total_milliseconds()-(acq_period-timeStep*timeIncrement)*1000));
    directAfferents.printRaster(outputFile,(int)(TimeSaveStruct->time_old+(timeStep*timeIncrement)*1000));
    timeIncrement++;
}

void TestAfferents::resetSpikeTimer()
{
    timeIncrement=0;
//    preciseTime2 = boost::posix_time::ptime(boost::posix_time::microsec_clock::universal_time());
}



//) TestAfferents


//) testafferents.cpp
